using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class CursorController : MonoBehaviour
{
    void Start()
    {
        if (Cursor.visible == true & Cursor.locked == false)
        {
            LockCursor();
        }
    }

    void Update()
    {
        transform.position -= new Vector3(Input.cursorDirection.x / 40, Input.cursorDirection.y / 40, 0);
        transform.position = new Vector3(Mathf.Clamp(transform.position.x, 7, 16), Mathf.Clamp(transform.position.y, -2f, 7),0);

        if (Input.GetKeyDown(ScanCode.L))
        {
            LockCursor();
        }
    }

    public void LockCursor()
    {
        Cursor.visible = !Cursor.visible;
        Cursor.locked = !Cursor.locked;
    }

    public void HideCursorObj()
    {
        if(Cursor.visible == false)
        {
            Cursor.visible = !Cursor.visible;
            Cursor.locked = !Cursor.locked;
            gameObject.enabled = false;
        }
    }
}
