using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class EnemySpear : MonoBehaviour
{
    private bool _spearhHasBeenThrown = false;
    private EnemySpearsSpawner _spearsSpawner;
    private GameObject _player;
    private GameObject _spike;
    private GameManager _gameManager;
    private float _timeToThrow = 1f;

    void Start()
    {
        _spearsSpawner = FindObjectOfType<EnemySpearsSpawner>();
        _player = GameObject.Find("PlayerBody");
        _spike = transform.GetChild(0).gameObject;
        _gameManager = FindObjectOfType<GameManager>();
    }

    void Update()
    {
        if (GameManager.GameHasStarted == false)
        {
            return;
        }

        if (_timeToThrow < 0 & _spearhHasBeenThrown == false)
        {
            rigidbody.isKinematic = false;
            rigidbody.linearVelocity = Vector3.right * 25;
            _spearhHasBeenThrown = true;
            _spearsSpawner.SpawnNewSpear();
            audioSource.Play();
        }
        else
        {
            _timeToThrow -= Time.deltaTime;
        }

        VehiclePart[] vehicleParts = FindObjectsOfType<VehiclePart>();
        foreach (var part in vehicleParts)
        {
            if (Vector3.Distance(_spike.transform.position, part.transform.position) < 2f)
            {
                Destroy(part.gameObject);
                Destroy(gameObject);
                break;
            }
        }


        if (_player != null)
        {
            if (Vector3.Distance(_spike.transform.position, _player.transform.position) < 2)
            {
                rigidbody.isKinematic = true;
                _gameManager.Restart();
                Destroy(gameObject);
            }
        }


    }
}
