using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class Spear : MonoBehaviour
{
	private bool _spearhHasBeenThrown = false;
	private SpearsSpawner _spearsSpawner;
	private Enemy _enemy;
	private GameObject _spike;
	private GameManager _gameManager;
	void Start()
	{
		_spearsSpawner = FindObjectOfType<SpearsSpawner>();
		_enemy = FindObjectOfType<Enemy>();
		_spike = transform.GetChild(0).gameObject;
		_gameManager = FindObjectOfType<GameManager>();
	}
	
	void Update()
	{
		if(GameManager.GameHasStarted == false)
		{
			return;
		}

		if (Input.GetMouseButtonDown(0) & _spearhHasBeenThrown == false)
		{
			rigidbody.isKinematic = false;
			rigidbody.linearVelocity = Vector3.left * 25;
			_spearhHasBeenThrown = true;
			_spearsSpawner.SpawnNewSpear();
			audioSource.Play();
		}

		EnemyVehiclePart[] _enemyVehicleParts = FindObjectsOfType<EnemyVehiclePart>();
		foreach (var part in _enemyVehicleParts)
		{
			if (Vector3.Distance(_spike.transform.position, part.transform.position) < 2.5f)
			{
				Destroy(part.gameObject);
				Destroy(gameObject);
				break;
			}
		}


		if (_enemy != null)
		{
            if (Vector3.Distance(_spike.transform.position, _enemy.transform.position) < 2.5f)
            {
               
                rigidbody.isKinematic = true;
				_gameManager.LoadNextLevel();
                Destroy(gameObject);
            }
        }
		

	}
}
