using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class VehicleCreator : MonoBehaviour
{
    public static List<GameObject> VehicleParts = new List<GameObject>();

    public Prefab VehiclePart;
	public Text MaterialsText;

	private CursorController _cursorController;
	private Vector3 _previousSpherePosition;
    private GameManager _gameManager;
	private PlayerMotor _playerMotor;
    private int _materials = 50;
	
	void Start()
	{
        _cursorController = FindObjectOfType<CursorController>();
		_gameManager = FindObjectOfType<GameManager>();
		_playerMotor = FindObjectOfType<PlayerMotor>();

        VehicleParts.Clear();
		UpdateMaterialsText();
	}
	
	void Update()
	{
		if (_cursorController == null | GameManager.GameHasStarted == true)
			return;

		if (Input.GetMouseButton(0))
		{
			if(Vector3.Distance( _cursorController.transform.position, _previousSpherePosition) > 0.5f)
			{
				CreateVehiclePart();
			}
		}

	}

	void CreateVehiclePart()
	{
		if (_materials > 0)
		{
            _previousSpherePosition = _cursorController.transform.position;
            GameObject vehiclePart = VehiclePart.Instantiate(_cursorController.transform.position, Quaternion.identity);
			vehiclePart.transform.parent = _playerMotor.transform;
			vehiclePart.AddComponent<VehiclePart>();
            VehicleParts.Add(vehiclePart);
			_materials -= 1;
			UpdateMaterialsText();
			audioSource.Play();
        }
		
    }
	void UpdateMaterialsText()
	{
		MaterialsText.text = _materials.ToString();
	}
}
